#include "Title.h"
#include "Sound.h"

//ʐpj[o[
typedef struct{						
	int x, y;						// Wi[pϐ
	char* name;						// ږi[pϐ
	int cmode;						//J[[h
}TitleElement_t;

//  J[[h
enum {
    CMODE_NORMAL,   //ʏ
    CMODE_ONMOUSE,  //ON MOUSE
};

//^Cgʍ\̂̕ϐ
static TitleElement_t TitleElement[2]={		
	{ 500, 500, "Q[X^[g", CMODE_NORMAL },			// ^O̒g̏ԂŊi[B
	{ 500, 570, "Q[I", CMODE_NORMAL },
};

//Gh^Cgʍ\̕ϐ̏
static TitleElement_t EndTitleElement[2]={
	{ 300, 500, "^Cgʂ",CMODE_NORMAL },
	{ 300, 570, "Q[I", CMODE_NORMAL },
};

static int GHtitle;
static int GHvictory;
static int GHgameover;
static int GHdraw;

static int title_sound_flag;

//Q[ʂ邽߂̊֐
void Title_init(){							
	GHtitle =  LoadGraph(TEXT("摜/title.png"));
	GHvictory = LoadGraph(TEXT("摜/.png"));
	GHgameover = LoadGraph(TEXT("摜/sk.png"));
	GHdraw = LoadGraph(TEXT("摜/.png"));

	title_sound_flag = 0;
}

//  vg^Cv錾
static int title_common( TitleElement_t titleElement[], int num);//ʃ^Cg֐
static void title_common_draw( TitleElement_t titleElement[], int num, int gh);//ʕ`̓֐


//  ^Cgʂ̊֐
int Title_main() {
	if(title_sound_flag == 0){
		Sound_Title(),
		title_sound_flag = 1;
	}
    return title_common(TitleElement,2);//ʃ^Cg֐
}
 
//  Gh^Cgʂ̊֐
int EndTitle_main() {
    return title_common(EndTitleElement,2);//ʃ^Cg֐
}

//^Cgʕ`֐
void Title_Draw(){								
	title_common_draw(TitleElement,2,GHtitle);//ʕ`̓֐
}

//ʕ`֐
void EndTitle_WinDraw(){							
    title_common_draw(EndTitleElement,2,GHvictory);//ʕ`̓֐
}

//skʕ`֐
void EndTitle_LoseDraw(){							
    title_common_draw(EndTitleElement,2,GHgameover);//ʕ`̓֐
}

//ʕ`֐
void EndTitle_DrawDraw(){							
    title_common_draw(EndTitleElement,2,GHdraw);//ʕ`̓֐
}

//ʃ^Cg֐
static int title_common( TitleElement_t titleElement[], int num){
    int nowinput ;
    int mx, my ;
 
    // }EX̓͏
    nowinput = 0 ;
    mx = 0 ;
    my = 0 ;
 
    // }EX̓͏(W)
    nowinput = GetMouseInput() ;
    GetMousePoint( &mx, &my ) ;
    
    //  j[̐
    for( int m=0 ; m<num ; m++ ) {
        //  ̕𓾂B
        int w = GetDrawStringWidth(titleElement[m].name,(int)strlen(titleElement[m].name));
        int h = 20;//͌ߑłB
        //  W
        int x = titleElement[m].x;
        int y = titleElement[m].y - 5;
        //  }EX̍WƔrB
        titleElement[m].cmode=CMODE_NORMAL; //ʏJ[
		if( (x <= mx) && (mx <= (x+w)) && (y <= my) && (my <= (y+h) )){
            titleElement[m].cmode=CMODE_ONMOUSE,    //on mouseJ[\F
			Sound_Title_select();		//ʉĐ
            //  }EX̍NbN
			if( ( nowinput & MOUSE_INPUT_LEFT ) != 0 ){
                //  ꂽɑΉԍAB
				if(m==0){
					return 1;
				}else if(m==1){
					return 2;
				}
			}
		}
    }
    return 0;
}

//  ʕ`̓֐
static void title_common_draw( TitleElement_t titleElement[], int num, int gh ){
    int i;    
    //  wi摜`
    DrawGraph(0,0,gh,FALSE);
    //  cmodeɂtitleElement[]̕FύX
    for( i=0; i<num; i++){              //j[ڕ`
        switch(titleElement[i].cmode){
        case CMODE_NORMAL:
            DrawFormatString( titleElement[i].x, titleElement[i].y, GetColor(255,255,255), TitleElement[i].name );
            break;
        case CMODE_ONMOUSE:
            DrawFormatString( titleElement[i].x, titleElement[i].y, GetColor(0,255,255), TitleElement[i].name );
            break;
        }
    }
}