#include "CPU_AI.h"
#include "Board.h"

//ċA֐̈΂߂\
typedef struct val_struct{
	int Tekikoma;
	int Mykoma;
	int cpuX;
	int cpuY;
	int playerX;
	int playerY;
	int cpuX_second;
	int cpuY_second;
	int valX;
	int valY;
	int val_point_array[3];
	int total;
	int level_rec;
	int search_count;
	int search_count_second;
}val_struct;

//vg^Cv錾
static int CPU_AI(int,int);
static void Check_val_point(int,int,val_struct *p_valst);
static void CPU_AI_rec(val_struct *p_valst);

//CPU̓͊֐
int CPU_input(int Tekikoma){

	int end = 0;

	val_struct valstruct ={Tekikoma,0,1,1,1,1,1,1,0,0,-100,-500,0,0,0};

	if(Tekikoma == BLACK){
		valstruct.Mykoma = WHITE;
	}else{
		valstruct.Mykoma = BLACK;
	}

	//ċA֐Ăяo
	CPU_AI_rec(&valstruct);

	WaitTimer( 1000 );										//vlԂ1b

	printf("ŏIvalX:%d,valY:%d\n",valstruct.valX,valstruct.valY);
	if(Board_Search(valstruct.valX, valstruct.valY, Tekikoma) >= 1){			//]l̈ԍWɃR}u
		Board_Flip(Tekikoma),								//R}Ԃ
		end = 1;
	}
	return end; 
}

//CPUAI֐
static int CPU_AI(int x,int y){
	int val_point = 0;

	int val_table[BAN_HEIGHT][BAN_WIDTH] =					//]z
	{  
		{-100,-100,-100,-100,-100,-100,-100,-100,-100,-100},
		{-100,100, -20,  20,   5,   5,  20, -20, 100, -100},  
		{-100,-20, -40,  -5,  -5,  -5,  -5, -40, -20, -100},  
		{-100, 20,  -5,  15,   3,   3,  15,  -5,  20, -100},  
		{-100,  5,  -5,   3,   3,   3,   3,  -5,   5, -100},  
		{-100,  5,  -5,   3,   3,   3,   3,  -5,   5, -100},  
		{-100, 20,  -5,  15,   3,   3,  15,  -5,  20, -100},  
		{-100,-20, -40,  -5,  -5,  -5,  -5, -40, -20, -100},  
		{-100,100, -20,  20,   5,   5,  20, -20, 100, -100},
		{-100,-100,-100,-100,-100,-100,-100,-100,-100,-100}
	};

	val_point = val_table[y][x];							//]lۑ
	return val_point;										//]lԂ
}

void Check_val_point(int x,int y,val_struct *p_valst){
	
	if(p_valst->level_rec == 0){
		//uꏊ̍W]֐֑
		p_valst->val_point_array[0] = CPU_AI(x,y);
		p_valst->cpuX = x,p_valst->cpuY = y;
	}else if(p_valst->level_rec == 1){
		//̒uW𑗂
		p_valst->val_point_array[1] = CPU_AI(x,y);
			p_valst->playerX = x,p_valst->playerY = y;
			printf("rplayerX:%d,playerY:%d,val_point:%d\n",p_valst->playerX,p_valst->playerY,p_valst->val_point_array[1]);
	}else if(p_valst->level_rec == 2){
		//uꏊ̍W]֐֑
		p_valst->val_point_array[2] = CPU_AI(x,y);
		//ځ[ځ{Oڂ̑]ꏊŏIƂ
		if(p_valst->total < (p_valst->val_point_array[0] - p_valst->val_point_array[1] + p_valst->val_point_array[2])){			//]Bl傫΍XV
			p_valst->total = p_valst->val_point_array[0] - p_valst->val_point_array[1] + p_valst->val_point_array[2],
			p_valst->valY = p_valst->cpuY, p_valst->valX = p_valst->cpuX;					//]W̍XV
			}
	}
}

void CPU_AI_rec(val_struct *p_valst){
	int x,y;
	printf("[vOX:%d   ,y:%d, level:%d\n",p_valst->cpuX,p_valst->cpuY,p_valst->level_rec);

	//ċAۂɉwڂɉĕϐɒl
	if(p_valst->level_rec == 0){
		x = p_valst->cpuX;
		y = p_valst->cpuY;
		p_valst->cpuX_second = 1;
		p_valst->cpuY_second = 1;
		p_valst->search_count = 0;
		p_valst->search_count_second = 0;
	}else if(p_valst->level_rec == 1){
		x = p_valst->playerX;
		y = p_valst->playerY;
	}else if(p_valst->level_rec == 2){
		x = p_valst->cpuX_second;
		y = p_valst->cpuY_second;
	}

	while( y < (BAN_HEIGHT -1)){					//WÂT[`֐֑
			//  ŏ̏Ԃۑ
            Board_CPU_BanData_push();
			//ċAKw̏
			if(p_valst->level_rec == 0){
				if(Board_Search(x,y,p_valst->Tekikoma) >= 1){
					//R}ԂAi񂾏Ԃɂ
					Board_Flip(p_valst->Tekikoma);
					//]l߂Ăߕ]֐Ăяo
					Check_val_point(x,y,p_valst);
					//ċAKwi[
					p_valst->level_rec += 1;
				}
				x++;
				//[v̒Eo
				if(x == (BAN_WIDTH -1)){
					x = 1, y += 1;
				}
				p_valst->cpuX = x;
				p_valst->cpuY = y;
				Board_CPU_BanData_pop();
				printf("CPUX:%d   ,y:%d\n",p_valst->cpuX,p_valst->cpuY);
				printf("x:%d   y:%d\n",x,y);
				CPU_AI_rec(p_valst);					//ċAĂяoB͍\
			}else if(p_valst->level_rec == 1){			//ċAKwԖ
				if(Board_Search(x,y,p_valst->Mykoma) >= 1){
					//pXǂJEg邽߂̕ϐɒl
					p_valst->search_count += 1;
					Check_val_point(x,y,p_valst);		//z̍ő]lT
					Board_Flip(p_valst->Mykoma);
					//ċAKwi[
					p_valst->level_rec += 1;
				}
				p_valst->playerX++;
				//[v̒Eo
				if(p_valst->playerX == (BAN_WIDTH -1)){
					p_valst->playerX = 1,p_valst->playerY++;
				}
				printf("v[[X:%d  ,Y:%d\n",x,y);
				Board_CPU_BanData_pop();
				//ċA
				CPU_AI_rec(p_valst);
			}else{					//ċAOKwځB_ōł[Kw
				if(Board_Search(x,y,p_valst->Tekikoma) >= 1){
					//pXǂf邽߂̕ϐɒl
					p_valst->search_count_second += 1;
					Check_val_point(x,y,p_valst);		//Oڂ̒uꏊ
				}
				p_valst->cpuX_second++;
				//[v̒Eo
				if(p_valst->cpuX_second == (BAN_WIDTH -1)){
					p_valst->cpuX_second = 1,p_valst->cpuY_second++;
				}
				Board_CPU_BanData_pop();
				//ċAĂяo
				CPU_AI_rec(p_valst);
			}
	}

	//v[[pXIȌ󋵂̂߁Atotal̒lőɂĂ̍WɃR}uĂ܂
	if(p_valst->playerY == (BAN_HEIGHT -1)){
		p_valst->level_rec = 0;
		if(p_valst->search_count == 0){
			p_valst->total = 300,	
			p_valst->valY = p_valst->cpuY, p_valst->valX = p_valst->cpuX;
			p_valst->cpuY = BAN_HEIGHT;
		}
	}
	if(p_valst->cpuY_second == (BAN_HEIGHT -1)){
		p_valst->level_rec = 0;
		if(p_valst->search_count_second == 0){
			p_valst->total = 300,
			p_valst->valY = p_valst->cpuY, p_valst->valX = p_valst->cpuX;
			p_valst->cpuY = BAN_HEIGHT;
		}
	}
	printf("֐IڑOX:%d   ,y:%d\n",p_valst->cpuX,p_valst->cpuY);
}