#include "Key.h"
#include "Board.h"
#include "Title.h"
#include "Game.h"
#include "Sound.h"

//[vŕKsR又
int ProcessLoop(){
	if(ProcessMessage()!=0)return -1;//vZXG[Ȃ-1Ԃ
	if(ClearDrawScreen()!=0)return -1;//ʃNAG[Ȃ-1Ԃ
	GetHitKeyStateAll_2();//݂̃L[͏s
	return 0;
}

int WINAPI WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nCmdShow){
	ChangeWindowMode(TRUE);		 //EBhE[hύX
	SetGraphMode( 640 , 640 , 32 ) ;
	if(DxLib_Init() == -1 || SetDrawScreen( DX_SCREEN_BACK )!=0) return -1;	//Ɨʉ

	enum func_state_enum { INIT, TITLE, GAME, TITLE_WIN, TITLE_LOSE, TITLE_DRAW };
	func_state_enum func_state = INIT ;

	#ifdef _DEBUG 
    AllocConsole();
    freopen("CONOUT$", "w", stdout); //Wo͂R\[ɂ
	#endif 

	//C[v
	while(ProcessLoop()==0){	
		int end = 0;
		int wait = 0;
		enum winner winner = NOONE;
		int choice = 0;
		int win = 0;

		switch(func_state){
			case INIT:
				Board_init();		//{[hɊւ鏉
				Sound_init();		//yɊւ鏉
				Title_init();		//^CgɊւ鏉
				func_state=TITLE;
				break;

			case TITLE :
				choice = Title_main();			//^Cgʕ\X^[gꂽGame֐
				switch(choice){
					case zokkou:
						func_state=GAME;
						break;
					case shuuryou:				//Q[I͂ꂽuCN
						end = 1;
						break;
				}
				Title_Draw();
				break;

			case GAME:		
					win = Game_main();	 		//Q[is֐
					switch(win){				//҂̔
						case USER:						
							func_state=TITLE_WIN;
							wait = 1;
							break;
						case CPU:
							func_state=TITLE_LOSE;
							wait = 1;
							break;
						case DRAW:
							func_state=TITLE_DRAW;
							wait = 1;
						default:			
							break;
						}
				Board_Draw();					//{[h̕\
				break;

			case TITLE_WIN:
				choice = EndTitle_main();
				switch(choice){
					case zokkou:
						func_state=INIT;
						break;
					case shuuryou:
						end = 1;
						break;
				}
				EndTitle_WinDraw();					//
				break;

			case TITLE_LOSE:
				choice = EndTitle_main();
				switch(choice){
					case zokkou:
						func_state=INIT;
						break;
					case shuuryou:
						end = 1;
						break;
				}
				EndTitle_LoseDraw();				//sk
				break;

			case TITLE_DRAW:
				choice = EndTitle_main();
				switch(choice){
					case zokkou:
						func_state=INIT;
						break;
					case shuuryou:
						end = 1;
						break;
				}
				EndTitle_DrawDraw();				//
				break;

			default:
				printfDx("sfunc_state\n");
				break;
		}
		if(CheckStateKey(KEY_INPUT_ESCAPE)==1)break;		//GXP[v͂ꂽuCN
		if(end == 1)break;									//end̒lPȂQ[I
		ScreenFlip();//ʔf
		if(wait == 1)WaitTimer( 5000 );				//sʕ\5b
	}

	DxLib_End(); // DXCuI
	return 0;
}  
